//class PSWPref
function PSWPref()
{
	this.pbi = Components.classes['@mozilla.org/preferences;1'].
	  getService(Components.interfaces.nsIPrefBranchInternal);
	this.pref = Components.classes["@mozilla.org/preferences-service;1"].
	  getService(Components.interfaces.nsIPrefBranch);
	this.PrefRegardNoneAsNormal = 'psw.regard_as_normal';
	this.PrefNotDeletePriority = 'psw.not_delete';
	this.PrefWarnDeletePriority = 'psw.warn_delete';
	this.PrefIgnoreJunk = 'psw.ignore_delete_junk';
	this.PrefAutoCommit = 'psw.auto_commit';
	this.PrefSaveOrgInTrash = 'psw.save_in_trash';
	this.PrefCommitImapOnly = 'psw.commit_imap_only';
	this.PrefCycleCell = 'psw.cycle_cell';
	this.PrefWarnDeleteStar = 'psw.warn_star';
	this.PrefIconTheme = 'psw.icon_theme';
	this.PrefChangeMessageId = 'psw.change_messageid_on_imap_commit';
	this.observers = new Array();

}

PSWPref.prototype.addPrefListener = function(obj, func, domain)
{
	var observer = new PSWPrefObserver(obj, func);
	this.pbi.addObserver(domain, observer, false);
	var key = (new Date()).getTime().toString();
	this.observers.push({domain: domain, observer: observer});
	return this.observers.length - 1;
}

PSWPref.prototype.removePrefListener = function(index)
{
	var observer = this.observers[index];
	this.pbi.removeObserver(observer.domain, observer.observer);
}

PSWPref.prototype.getPriorityNotForDeletion = function()
{
	return nsPreferences.getIntPref(this.PrefNotDeletePriority,PSWMsgPriorityValue.high);
}

PSWPref.prototype.getPriorityNeedsWarning = function()
{
	return nsPreferences.getIntPref(this.PrefWarnDeletePriority,PSWMsgPriorityValue.high);
}
PSWPref.prototype.warnDeletionWithStar = function()
{
	return nsPreferences.getBoolPref(this.PrefWarnDeleteStar,false);
}

PSWPref.prototype.doesIgnoreHighPriorityJunkDeletion = function()
{
	return nsPreferences.getBoolPref(this.PrefIgnoreJunk,true);
}

PSWPref.prototype.regardNoneAsNormal = function()
{
	return nsPreferences.getBoolPref(this.PrefRegardNoneAsNormal,true);
}

PSWPref.prototype.useAutoCommit = function()
{
	return nsPreferences.getBoolPref(this.PrefAutoCommit,true);
}

PSWPref.prototype.saveOrgInTrashOnCommit = function()
{
	return nsPreferences.getBoolPref(this.PrefSaveOrgInTrash,true);
}

PSWPref.prototype.commitOnlyForImap = function()
{
	return nsPreferences.getBoolPref(this.PrefCommitImapOnly,true);
}

PSWPref.prototype.cycleCell = function()
{
	return nsPreferences.getBoolPref(this.PrefCycleCell,true);
}

PSWPref.prototype.getIconTheme = function()
{
	return nsPreferences.copyUnicharPref(this.PrefIconTheme,"");
}

PSWPref.prototype.changeMessageIdOnIMAPCommit = function(server)
{
	return server.type == "imap" && nsPreferences.getBoolPref("mail.server."+server.key+"."+this.PrefChangeMessageId, false);
}

//class PSWObserver
function PSWObserver(caller, callee)
{
	this.caller = caller;
	this.callee = callee;
}

PSWObserver.prototype.observe = function(subject, topic, data)
{
	this.callee.apply(this.caller,arguments);
}

//class PSWPrefObserver
function PSWPrefObserver(caller, callee)
{
	this.caller = caller;
	this.callee = callee;
}

PSWPrefObserver.prototype.observe = function(subject, topic, prefstring)
{
	if (topic == 'nsPref:changed') {
		this.callee.apply(this.caller,[]);
	}
}
